'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _isPromise = require('is-promise');

var _isPromise2 = _interopRequireDefault(_isPromise);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Triggers an asynchronous hook pipeline. Each hook can change
 * the input to the next via the `transform` callback.
 * @param  {Object} pipeline - Describes what hooks to call and how.
 * @param  {Array} pipeline.hooks - A list of functions to call.
 * @param  {Array} pipeline.initial - The initial value to start with.
 * @param  {Function} pipeline.transform - The initial value to start with.
 * @return {Promise} - Resolves to the final arguments output.
 */
exports.default = function () {
  var _ref = (0, _asyncToGenerator3.default)(_regenerator2.default.mark(function _callee(_ref2) {
    var transform = _ref2.transform,
        initial = _ref2.initial,
        hooks = _ref2.hooks;

    var result, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, hook, output;

    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            result = initial;
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context.prev = 4;
            _iterator = (0, _getIterator3.default)(hooks);

          case 6:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context.next = 17;
              break;
            }

            hook = _step.value;
            output = hook.call(this, result);

            if (!(0, _isPromise2.default)(output)) {
              _context.next = 13;
              break;
            }

            _context.next = 12;
            return output;

          case 12:
            output = _context.sent;

          case 13:

            result = transform(output, result);

          case 14:
            _iteratorNormalCompletion = true;
            _context.next = 6;
            break;

          case 17:
            _context.next = 23;
            break;

          case 19:
            _context.prev = 19;
            _context.t0 = _context['catch'](4);
            _didIteratorError = true;
            _iteratorError = _context.t0;

          case 23:
            _context.prev = 23;
            _context.prev = 24;

            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }

          case 26:
            _context.prev = 26;

            if (!_didIteratorError) {
              _context.next = 29;
              break;
            }

            throw _iteratorError;

          case 29:
            return _context.finish(26);

          case 30:
            return _context.finish(23);

          case 31:
            return _context.abrupt('return', result);

          case 32:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[4, 19, 23, 31], [24,, 26, 30]]);
  }));

  return function (_x) {
    return _ref.apply(this, arguments);
  };
}();